#include<stdio.h>
#include<gtk/gtk.h>
#include<glade/glade.h>

/*
(C) Feb 2005 Muthiah Annamalai, Octave-GTK & Octave-libGlade
*/

void on_spin_activate(GtkSpinButton *b);
void on_spin_changed(GtkSpinButton *b);

GladeXML *gx;

int main(int argc,char *argv[])
{  
  GtkWidget *w;

  gtk_init(&argc,&argv);
  gx=glade_xml_new("gnu.glade",NULL,NULL);
  g_assert(gx != NULL);

  glade_xml_signal_autoconnect(gx);
  w=glade_xml_get_widget(gx,"window");

  g_signal_connect(G_OBJECT(w),"destroy",G_CALLBACK(gtk_main_quit),NULL);
  gtk_widget_show_all(w);

  gtk_main();
  return 0;
}

void on_spin_changed(GtkSpinButton *b)
{
  gint count=0;
  char buffer[10];  
  GtkLabel *label=GTK_LABEL(glade_xml_get_widget(gx,"label"));
  count=gtk_spin_button_get_value_as_int(b);
  sprintf(buffer,"%3d",count);
  gtk_label_set_text(label,buffer);
  printf("changed: %s <=> %d\n",buffer,count);
}

void on_spin_activate(GtkSpinButton *b)
{
  //Doesnt work.
  unsigned char count=0;
  char buffer[10];
  GtkLabel *label=GTK_LABEL(glade_xml_get_widget(gx,"label"));
  count=gtk_spin_button_get_value_as_int(b);
  sprintf(buffer,"%d",count);
  gtk_label_set_text(label,buffer);
  printf("actiavted: %s <=> %d\n",buffer,count);
}

/**
gcc -o gnu  -Wall gnu.c `pkg-config gtk+-2.0 --cflags --libs` -I/usr/include/libglade-2.0 -lxml -lglade-2.0
*/
