#! /usr/bin/octave -q

% A simple program to show
% the Use of "Arrow Widgets" from Octave-GTK.
% (C) Feb 2005 Muthiah Annamalai


% Create an Arrow widget with the specified parameters
% and pack it into a button 
function button=create_arrow_button(arrow_type, shadow_type )
  button=0;
  arrow=0;

  button = gtk_button_new ();
  arrow = gtk_arrow_new (arrow_type, shadow_type);

  gtk_container_add (button, arrow);
  
  gtk_widget_show (button);
  gtk_widget_show (arrow);

  return
end

function main( )
     %load library
     gtk()

     %initation
     gtk_init()

     %some enums: ugly but works... ;-0
     FALSE=0;
     TRUE=1;
     GTK_ARROW_UP=0;
     GTK_ARROW_DOWN=1;
     GTK_ARROW_LEFT=2;
     GTK_ARROW_RIGHT=3;
     
     GTK_SHADOW_NONE=0;
     GTK_SHADOW_IN=1;
     GTK_SHADOW_OUT=2;
     GTK_SHADOW_ETCHED_IN=3;
     GTK_SHADOW_ETCHED_OUT=4;
  
     GTK_WINDOW_TOPLEVEL=0;
     
     %/* Initialize the toolkit */
     gtk_init();
     
     %/* Create a new window */
     window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
     
     gtk_window_set_title(window, "Arrow Buttons");
     
     %/* It's a good idea to do this for all windows. */
     g_signal_connect (window,"destroy","gtk_main_quit");
     
     %/* Sets the border width of the window. */
     gtk_container_set_border_width (window, 10);
     
     %/* Create a box to hold the arrows/buttons */
     box = gtk_hbox_new (FALSE, 0);
     gtk_container_set_border_width (box, 2);
     gtk_container_add(window, box);
     
     %/* Pack and show all our widgets */
     gtk_widget_show (box);
     
     button = create_arrow_button (GTK_ARROW_UP, GTK_SHADOW_IN);
     gtk_box_pack_start (box, button, FALSE, FALSE, 3);
     
     button = create_arrow_button (GTK_ARROW_DOWN, GTK_SHADOW_OUT);
     gtk_box_pack_start (box, button, FALSE, FALSE, 3);
     
     button = create_arrow_button (GTK_ARROW_LEFT, GTK_SHADOW_ETCHED_IN);
     gtk_box_pack_start (box, button, FALSE, FALSE, 3);
  
     button = create_arrow_button (GTK_ARROW_RIGHT, GTK_SHADOW_ETCHED_OUT);
     gtk_box_pack_start (box,button, FALSE, FALSE, 3);
     
     gtk_widget_show (window);
     
%    Rest in gtk_main and wait for the fun to begin!
     gtk_main ();
     return ;
end

main()
