#! /usr/bin/octave -q
spinner1=0;
spin=0;
label=0;
function toggle_snap(widget)
  global spinner1
  spin=spinner1
  disp('Toggle Snap')
  gtk_spin_button_set_snap_to_ticks (spin, gtk_toggle_button_get_active(widget));
end

function toggle_numeric(widget)
  global spinner1
  spin=spinner1
  disp('Toggle Numeric')
  gtk_spin_button_set_numeric(spin, gtk_toggle_button_get_active(widget));
end

function change_digits(widget)	
  global spinner1
  spin=spinner1
  disp('Change Digits')
  gtk_spin_button_set_digits(spin, gtk_spin_button_get_value_as_int (spin));
end

function get_value_int(widget)
     global  spinner1;
     global label;
     buf="";

     spin=0;
     disp('Get Value')
     spin = (spinner1);

     buf=sprintf ("%d", gtk_spin_button_get_value_as_int (spin));
     gtk_label_set_text (label, buf);
end

function get_value_float(widget)
     global  spinner1;
     global label;
     buf="";

     spin=0;
     disp('Get Value')

     spin = (spinner1);
     buf=sprintf ("%f", gtk_spin_button_get_value (spin));
     gtk_label_set_text (label, buf);
end


function main()  
  global spinner1=0;
  global label=0;
  window=0;
  frame=0;
  hbox=0;
  main_vbox=0;
  vbox=0;
  vbox2=0;
  spinner2=0;
  button=0;
  adj=0;

  %/* Initialise GTK */
  gtk()

  gtk_init ();

  GTK_WINDOW_TOPLEVEL=0
  FALSE=0;
  TRUE=1;

  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);

  g_signal_connect ((window), "destroy",
		    "gtk_main_quit")

  gtk_window_set_title ((window), "Spin Button");

  main_vbox = gtk_vbox_new (FALSE, 5);
  gtk_container_set_border_width ((main_vbox), 10);
  gtk_container_add ((window), main_vbox);
  
  frame = gtk_frame_new ("Not accelerated");
  gtk_box_pack_start ((main_vbox), frame, TRUE, TRUE, 0);
  
  vbox = gtk_vbox_new (FALSE, 0);
  gtk_container_set_border_width ((vbox), 5);
  gtk_container_add ((frame), vbox);
  
  %/* Day, month, year spinners */
  
  hbox = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start ((vbox), hbox, TRUE, TRUE, 5);
  
  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_box_pack_start ((hbox), vbox2, TRUE, TRUE, 5);
  
  dlabel = gtk_label_new ("Day :");
  gtk_misc_set_alignment ((dlabel), 0, 0.5);
  gtk_box_pack_start ((vbox2), dlabel, FALSE, TRUE, 0);
  
  adj =  gtk_adjustment_new (1.0, 1.0, 31.0, 1.0,
					      5.0, 0.0);
  spinner1 = gtk_spin_button_new (adj, 0, 0);
  gtk_spin_button_set_wrap ((spinner1), TRUE);
  gtk_box_pack_start ((vbox2), spinner1, FALSE, TRUE, 0);
  
  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_box_pack_start ((hbox), vbox2, TRUE, TRUE, 5);
  
  dlabel = gtk_label_new ("Month :");
  gtk_misc_set_alignment ((dlabel), 0, 0.5);
  gtk_box_pack_start ((vbox2), dlabel, FALSE, TRUE, 0);
  
  adj = gtk_adjustment_new (1.0, 1.0, 12.0, 1.0,5.0, 0.0);
  spinner = gtk_spin_button_new (adj, 0, 0);
  gtk_spin_button_set_wrap ((spinner), TRUE);
  gtk_box_pack_start ((vbox2), spinner, FALSE, TRUE, 0);
  
  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_box_pack_start ((hbox), vbox2, TRUE, TRUE, 5);
  
  dlabel = gtk_label_new ("Year :");
  gtk_misc_set_alignment ((dlabel), 0, 0.5);
  gtk_box_pack_start ((vbox2), dlabel, FALSE, TRUE, 0);
  
  adj =gtk_adjustment_new (1998.0, 0.0, 2100.0,1.0, 100.0, 0.0);
  spinner = gtk_spin_button_new (adj, 0, 0);
  gtk_spin_button_set_wrap ((spinner), FALSE);
  gtk_widget_set_size_request (spinner, 55, -1);
  gtk_box_pack_start ((vbox2), spinner, FALSE, TRUE, 0);
  
  frame = gtk_frame_new ("Accelerated");
  gtk_box_pack_start ((main_vbox), frame, TRUE, TRUE, 0);
  
  vbox = gtk_vbox_new (FALSE, 0);
  gtk_container_set_border_width ((vbox), 5);
  gtk_container_add ((frame), vbox);
  
  hbox = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start ((vbox), hbox, FALSE, TRUE, 5);
  
  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_box_pack_start ((hbox), vbox2, TRUE, TRUE, 5);
  
  dlabel = gtk_label_new ("Value :");
  gtk_misc_set_alignment ((dlabel), 0, 0.5);
  gtk_box_pack_start ((vbox2), dlabel, FALSE, TRUE, 0);
  
  adj =gtk_adjustment_new (0.0, -10000.0, 10000.0,0.5, 100.0, 0.0);
  spinner1 = gtk_spin_button_new (adj, 1.0, 2);
  gtk_spin_button_set_wrap ((spinner1), TRUE);
  gtk_widget_set_size_request (spinner1, 100, -1);
  gtk_box_pack_start ((vbox2), spinner1, FALSE, TRUE, 0);
  
  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_box_pack_start ((hbox), vbox2, TRUE, TRUE, 5);
  
  dlabel = gtk_label_new ("Digits :");
  gtk_misc_set_alignment((dlabel), 0, 0.5);
  gtk_box_pack_start ((vbox2), dlabel, FALSE, TRUE, 0);
  
  adj = gtk_adjustment_new (2, 1, 5, 1, 1, 0);
  spinner2 = gtk_spin_button_new (adj, 0.0, 0);
  gtk_spin_button_set_wrap((spinner2), TRUE);
  g_signal_connect ((adj), "value_changed","change_digits")
  gtk_box_pack_start ((vbox2), spinner2, FALSE, TRUE, 0);
  
  hbox = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start ( (vbox), hbox, FALSE, TRUE, 5);
  
  button = gtk_check_button_new_with_label ("Snap to 0.5-ticks");
  g_signal_connect ((button), "clicked", "toggle_snap")
  gtk_box_pack_start ((vbox), button, TRUE, TRUE, 0);
  gtk_toggle_button_set_active ((button), TRUE);
  
  button = gtk_check_button_new_with_label ("Numeric only input mode");
  g_signal_connect ((button), "clicked",("toggle_numeric"))

  gtk_box_pack_start ((vbox), button, TRUE, TRUE, 0);
  gtk_toggle_button_set_active ((button), TRUE);
  
  label = gtk_label_new ("");
  
  hbox = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start ( (vbox), hbox, FALSE, TRUE, 5);
  button = gtk_button_new_with_label ("Value as Int");
  g_signal_connect ((button), "clicked", "get_value_int");
  gtk_box_pack_start ((hbox), button, TRUE, TRUE, 5);
  
  button = gtk_button_new_with_label ("Value as Float");
  g_signal_connect ((button), "clicked", "get_value_float")

  gtk_box_pack_start ( (hbox), button, TRUE, TRUE, 5);
  
  gtk_box_pack_start ((vbox), label, TRUE, TRUE, 0);
  gtk_label_set_text ((label), "0");
  
  hbox = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start ((main_vbox), hbox, FALSE, TRUE, 0);
  
  button = gtk_button_new_with_label ("Close");
  g_signal_connect((button), "clicked",("gtk_main_quit"))
  gtk_box_pack_start ((hbox), button, TRUE, TRUE, 5);

  gtk_widget_show_all (window);

  %/* Enter the event loop */
  gtk_main ();
    
  return
end

main()