#! /usr/bin/octave -q

% A simple program to show
% the Use of "Aspect Frame Widgets" from Octave-GTK.
% (C) Feb 2005 Muthiah Annamalai


function rval=create_bbox(horizontal,
                     title,
		     spacing,
                     child_w,
                     child_h,
                     layout )

  GTK_STOCK_OK="gtk-ok";
  GTK_STOCK_CANCEL="gtk-cancel";
  GTK_STOCK_HELP="gtk-help";

  frame=0;
  bbox=0;
  button=0;

  frame = gtk_frame_new (title);

  if (horizontal)
    bbox = gtk_hbutton_box_new ();
  else
    bbox = gtk_vbutton_box_new ();
  end

  gtk_container_set_border_width ( bbox, 5);
  gtk_container_add ( frame, bbox);

  %/* Set the appearance of the Button Box */
  gtk_button_box_set_layout (bbox, layout);
  gtk_box_set_spacing (bbox, spacing);

  %/*gtk_button_box_set_child_size (bbox, child_w, child_h);*/

  button = gtk_button_new_from_stock (GTK_STOCK_OK);
  gtk_container_add (bbox, button);

  button = gtk_button_new_from_stock (GTK_STOCK_CANCEL);
  gtk_container_add (bbox, button);

  button = gtk_button_new_from_stock (GTK_STOCK_HELP);
  gtk_container_add (bbox, button);

  rval=frame
  return;
end


function main( )
     window=0;
     main_vbox=0;
     vbox=0;
     hbox=0;
     frame_horz=0;
     frame_vert=0;

     %load library
     gtk()

     %initation
     gtk_init()

     %some enums: ugly but works... ;-0
     FALSE=0;
     TRUE=1;

     GTK_WINDOW_TOPLEVEL=0;

     GTK_BUTTONBOX_DEFAULT_STYLE=0;
     GTK_BUTTONBOX_SPREAD=1;
     GTK_BUTTONBOX_EDGE=2;
     GTK_BUTTONBOX_START=3;
     GTK_BUTTONBOX_END=4;
   
     
     %%/* Initialize the toolkit */
     gtk_init();
     
     %%/* Create a new window */
     window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
     
     %gtk_window_set_title(window, "Aspect Frame");     
     %%/* It's a good idea to do this for all windows. */
     g_signal_connect (window,"destroy","gtk_main_quit");
     gtk_container_set_border_width ( window, 10);
   

     main_vbox = gtk_vbox_new (FALSE, 0);
     gtk_container_add (window, main_vbox);

     frame_horz = gtk_frame_new ("Horizontal Button Boxes");
     gtk_box_pack_start ( main_vbox, frame_horz, TRUE, TRUE, 10);

     vbox = gtk_vbox_new (FALSE, 0);
     gtk_container_set_border_width ( (vbox), 10);
     gtk_container_add ( frame_horz, vbox);

     gtk_box_pack_start (vbox,
			 create_bbox (TRUE, "Spread (spacing 40)",
				      40, 85, 20, GTK_BUTTONBOX_SPREAD),
			 TRUE, TRUE, 0);

     gtk_box_pack_start ( vbox,
			 create_bbox (TRUE, "Edge (spacing 30)", 
				      30, 85, 20, GTK_BUTTONBOX_EDGE),
			 TRUE, TRUE, 5);

     gtk_box_pack_start ( vbox,
			 create_bbox (TRUE, "Start (spacing 20)",
				      20, 85, 20, GTK_BUTTONBOX_START),
			 TRUE, TRUE, 5);

      gtk_box_pack_start ( vbox,
			  create_bbox (TRUE, "End (spacing 10)", 
				       10, 85, 20, GTK_BUTTONBOX_END),
			  TRUE, TRUE, 5);

      frame_vert = gtk_frame_new ("Vertical Button Boxes");
      gtk_box_pack_start ( main_vbox, frame_vert, TRUE, TRUE, 10);
      
      hbox = gtk_hbox_new (FALSE, 0);
      gtk_container_set_border_width ( (hbox), 10);
      gtk_container_add ( frame_vert, hbox);
      
      gtk_box_pack_start ( hbox,
			  create_bbox (FALSE, "Spread (spacing 5)", 
				       5, 85, 20, GTK_BUTTONBOX_SPREAD),
			  TRUE, TRUE, 0);

  gtk_box_pack_start ( (hbox),
		      create_bbox (FALSE, "Edge (spacing 30)",
				   30, 85, 20, GTK_BUTTONBOX_EDGE),
		      TRUE, TRUE, 5);

  gtk_box_pack_start ( (hbox),
		      create_bbox (FALSE, "Start (spacing 20)", 
				   20, 85, 20, GTK_BUTTONBOX_START),
		      TRUE, TRUE, 5);

  gtk_box_pack_start ( (hbox),
		      create_bbox (FALSE, "End (spacing 20)",
				   20, 85, 20, GTK_BUTTONBOX_END),
		      TRUE, TRUE, 5);

  gtk_widget_show_all (window);

  %/* Enter the event loop */
  gtk_main ();
  return ;
end

main()    