#! /usr/bin/octave -q

% A simple program to show
% the Use of "Entry+Buttons" from Octave-GTK.

TRUE=1;
entry=0

function enter_callback(widget)
  global entry;
  disp(gtk_widget_get_name(widget))
  entry_text = gtk_entry_get_text (entry);
  printf("Entry contents: %s\n", entry_text);
end


function entry_toggle_editable( checkbutton)
  global entry
  disp(gtk_widget_get_name(checkbutton))
  gtk_editable_set_editable (entry,
                             gtk_toggle_button_get_active(checkbutton));
end

function entry_toggle_visibility(checkbutton)
  global entry
  disp(gtk_widget_get_name(checkbutton))
  gtk_entry_set_visibility (entry,
			    gtk_toggle_button_get_active(checkbutton));
end


function main()
  global entry;
  window=0;
  vbox=0;
  hbox=0;
  button=0;
  check=0;
  tmp_pos=0;

  FALSE=0
  TRUE=0;

  GTK_WINDOW_TOPLEVEL=0
  GTK_STOCK_CLOSE = "gtk-close";

  %load library
  gtk()
  
  %initation
  gtk_init()
  
  %creation-
  w=gtk_window_new(0)
  b=gtk_vbox_new(0,0)
  
  gtk_window_set_title(w,"Welcome to Octave-GTK");
  entry=gtk_entry_new();
  
  %/* create a new window */
  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  g_signal_connect(window,"destroy","gtk_main_quit");
  gtk_widget_set_size_request (window, 200, 100);
  gtk_window_set_title (window, "GTK Entry");
  g_signal_connect (window, "destroy","gtk_main_quit");

  vbox = gtk_vbox_new (FALSE, 0);
  gtk_container_add ((window), vbox);
  gtk_widget_show (vbox);
    
  entry = gtk_entry_new ();
  gtk_entry_set_max_length ((entry), 50);
  g_signal_connect ((entry), "activate","enter_callback")		      
  gtk_entry_set_text ((entry), "hello world");
  gtk_editable_select_region ( (entry),
			      0,length("hello world"));

  gtk_box_pack_start ( (vbox), entry, TRUE, TRUE, 0);
  gtk_widget_show (entry);

  hbox = gtk_hbox_new (FALSE, 0);
  gtk_container_add (vbox, hbox);
  gtk_widget_show (hbox);
                                  
  check = gtk_check_button_new_with_label ("Editable");
  gtk_box_pack_start ( (hbox), check, TRUE, TRUE, 0);
  g_signal_connect ( (check), "toggled",
	             "entry_toggle_editable");
  gtk_toggle_button_set_active ((check), TRUE);
  gtk_widget_show (check);
    
  check = gtk_check_button_new_with_label ("Visible");
  gtk_box_pack_start ((hbox), check, TRUE, TRUE, 0);
  g_signal_connect ((check), "toggled",
	            "entry_toggle_visibility");
  gtk_toggle_button_set_active ((check), TRUE);
  gtk_widget_show (check);
  
  button = gtk_button_new_from_stock (GTK_STOCK_CLOSE);
  g_signal_connect(button, "clicked","gtk_main_quit")

  gtk_box_pack_start ((vbox), button, TRUE, TRUE, 0);

  %(button, GTK_CAN_DEFAULT);
  gtk_widget_grab_default (button);
  gtk_widget_show (button);  

  gtk_widget_show (window);  
  
  
  %enter main loop
  gtk_main()
end

main()
