#! /usr/bin/octave -q

% A simple program to show
% the Use of "FileSelection Widgets" from Octave-GTK.
% (C) Feb 2005 Muthiah Annamalai


#include <gtk/gtk.h>

%/* Get the selected filename and print it to the console */
filew=0

function file_ok_sel(w)
   global filew
   printf("file_ok_sel: %s\n", gtk_file_selection_get_filename(filew));
end

function main()
    global filew;
    filew=0;
    gtk();

    gtk_init();

    %/* Create a new file selection widget */    
    filew = gtk_file_selection_new ("File selection");
    
    g_signal_connect(filew,"destroy","gtk_main_quit");

    %/* Connect the ok_button to file_ok_sel function */
    g_signal_connect(gtk_file_selection_get_widget(filew,"ok"),
		     "clicked","file_ok_sel");
    
    %/* Connect the cancel_button to destroy the widget */
    g_signal_connect(gtk_file_selection_get_widget(filew,"cancel"),
		     "clicked", "gtk_main_quit");
    
    %/* Lets set the filename, as if this were a save dialog, and we are giving
    % a default filename */
    gtk_file_selection_set_filename (filew,"penguin.png");
    
    gtk_widget_show (filew);
    gtk_main ();
    return ;
end

main()
