#! /usr/bin/octave -q


%%/* Print a string when a menu item is selected */
function menuitem_response( string )
     printf("%d",string)
end


%%/* Respond to a button-press by posting a menu passed in as widget.
% *
% * Note that the "widget" argument is the menu being posted, NOT
% * the button that was pressed.
% */

function rval=button_press(widget)
     TRUE=1
     FALSE=0

     if 1 > 0
        %gtk_menu_popup (widget,);		     
        %%/* Tell calling code that we have handled this event; the buck
        %* stops here. */
        rval=1
        return ;
     end
     rval=0;
     return  
end


function main()            
    gtk()

    window=0;
    menu=0;
    menu_bar=0;
    root_menu=0;
    menu_items=0;
    vbox=0;
    button=0;
    buf=""
    i=0



    gtk_init ();

    FALSE =0;
    TRUE = 1;
    GTK_WINDOW_TOPLEVEL=0;

    %/* create a new window */
    window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_widget_set_size_request ( (window), 200, 100);
    gtk_window_set_title ( (window), "GTK Menu Test");
    g_signal_connect ((window), "delete_event",
		      "gtk_main_quit");

    %/* Init the menu-widget, and remember -- never
    % * gtk_show_widget() the menu widget!! 
    % * This is the menu that holds the menu items, the one that
    % * will pop up when you click on the "Root Menu" in the app */
    menu = gtk_menu_new ();

    %/* Next we make a little loop that makes three menu-entries for "test-menu".
    % * Notice the call to gtk_menu_shell_append.  Here we are adding a list of
    % * menu items to our menu.  Normally, we'd also catch the "clicked"
    % * signal on each of the menu items and setup a callback for it,
    % * but it's omitted here to save space. */

    for i=1:3
            %/* Copy the names to the buf. */
            buf=sprintf ("Test-undermenu - %d", i);

            %/* Create a new menu-item with a name... */
            menu_items = gtk_menu_item_new_with_label (buf);

            %/* ...and add it to the menu. */
            gtk_menu_shell_append ( (menu), menu_items);

	    %/* Do something interesting when the menuitem is selected */
            g_signal_connect(menu_items,"activate",
			     "menuitem_response")

            %/* Show the widget */
            gtk_widget_show (menu_items);
     end

    %/* This is the root menu, and will be the label
    % * displayed on the menu bar.  There won't be a signal handler attached,
    % * as it only pops up the rest of the menu when pressed. */
    root_menu = gtk_menu_item_new_with_label ("Root Menu");

    gtk_widget_show (root_menu);

    %/* Now we specify that we want our newly created "menu" to be the menu
    % * for the "root menu" */
    gtk_menu_item_set_submenu (root_menu, menu);

    %/* A vbox to put a menu and a button in: */
    vbox = gtk_vbox_new (FALSE, 0);
    gtk_container_add ( (window), vbox);
    gtk_widget_show (vbox);

    %/* Create a menu-bar to hold the menus and add it to our main window */
    menu_bar = gtk_menu_bar_new ();
    gtk_box_pack_start ((vbox), menu_bar, FALSE, FALSE, 2);
    gtk_widget_show (menu_bar);

    %/* Create a button to which to attach menu as a popup */
    button = gtk_button_new_with_label ("press me");
    g_signal_connect ( (button), "event",
			       "button_press")
    gtk_box_pack_end ((vbox), button, TRUE, TRUE, 2);
    gtk_widget_show (button);

    %/* And finally we append the menu-item to the menu-bar -- this is the
    % * "root" menu-item I have been raving about =) */
    gtk_menu_shell_append ((menu_bar), root_menu);

    %/* always display the window as the last step so it all splashes on
    % * the screen at once. */
    gtk_widget_show (window);

    gtk_main ();

    return;
end

main()
