#! /usr/bin/octave -q

% A simple program to show
% the Use of Menus from Octave-GTK.
global tempx
function menus=create_menu()
         w=gtk_window_new(0)
         menus = gtk_menu_new()
         menuitem = gtk_tearoff_menu_item_new()
         gtk_menu_shell_append(menus,menuitem);

         for i=1:5          
             data=sprintf("item %d",i);
             mlabels(i) = gtk_menu_item_new_with_label(data);
	     gtk_menu_shell_append(menus,mlabels(i));
	 end	 
        gtk_container_add(w,menus)
        gtk_widget_show_all(w)
end


function main()
     %load library
     gtk()

     %initation
     gtk_init()

     %creation
     w=gtk_window_new(0)
     b=gtk_vbox_new(0,0)

     gtk_window_set_title(w,"Octave-GTK Logo")

     img=gtk_image_new_from_file("octave-gtk.png")
     okb=gtk_button_new_with_label("ok")

     %packing 
     gtk_container_add(w,b)
     gtk_container_add(b,img)
     gtk_container_add(b,okb)


     %hookup the signals
     g_signal_connect(okb,"clicked","gtk_main_quit")
     g_signal_connect(w,"destroy","gtk_main_quit")
     
     %show all
     gtk_widget_show_all(w)

     create_menu()

     %enter main loop
     gtk_main()
end

main()
