#!/usr/bin/octave -q
%(c) 2005 March, Muthiah Annamalai

pdata={}; %global function.


%/* Update the value of the progress bar so that we get
% * some movement */
function rval=progress_timeout()
  global pdata;
  new_val=0.0;
  TRUE=1
  FALSE=0
  
  printf("Hello!")

  rval=TRUE;
  return

  if (pdata.activity_mode) 
    gtk_progress_bar_pulse (pdata.pbar);
  else 
    %/* Calculate the value of the progress bar using the
    %* value range set in the adjustment object */
      
    new_val = gtk_progress_bar_get_fraction ((pdata.pbar)) + 0.01;
      
    if (new_val > 1.0)
      new_val = 0.0;
    end
    %/* Set the new value */
    gtk_progress_bar_set_fraction ((pdata.bar), new_val);
    
    %/* As this is a timeout funcn, return TRUE so that it
    %* continues to get called */
  end
  rval=TRUE;
  return ;
end

%/* Callback that toggles the text display within the progress bar trough */
function toggle_show_text(widget)
  global pdata;
  text = gtk_progress_bar_get_text (pdata.pbar);  
  gtk_progress_bar_set_text ((pdata.pbar), "some text");
end

%/* Callback that toggles the activity mode of the progress bar */
function toggle_activity_mode(widget)
  global pdata
  pdata.activity_mode = 1-pdata.activity_mode;
  if (pdata.activity_mode) 
    gtk_progress_bar_pulse (pdata.pbar);
  else
    gtk_progress_bar_set_fraction (pdata.pbar, 0.0);
  end
end

 
%/* Callback that toggles the orientation of the progress bar */
function toggle_orientation(widget)
  global pdata;
  GTK_PROGRESS_LEFT_TO_RIGHT=0;
  GTK_PROGRESS_RIGHT_TO_LEFT=1;

  val=pdata.pbar;
  val
  typeinfo(val)
  printf("%s\n","");
  gtk_widget_get_name(val)

  switch gtk_progress_bar_get_orientation (pdata.pbar)
    case GTK_PROGRESS_LEFT_TO_RIGHT
      gtk_progress_bar_set_orientation (pdata.pbar,GTK_PROGRESS_RIGHT_TO_LEFT);
    case GTK_PROGRESS_RIGHT_TO_LEFT
      gtk_progress_bar_set_orientation ((pdata.pbar),GTK_PROGRESS_LEFT_TO_RIGHT);
  end 
end

 
%/* Clean up allocated memory and remove the timer */
function destroy_progress(widget)
    global pdata
    gtk_timeout_remove (pdata.timer);
    gtk_main_quit ();
end

function main() 
    global pdata={}
    pdata.window=0
    pdata.pbar=0
    pdata.timer=0
    pdata.activity_mode=0
    gtk()
    gtk_init ();

    %/* Allocate memory for the data that is passed to the callbacks */
  
    %FIXME: we will add the enumerators very soon!
    GTK_WINDOW_TOPLEVEL=0;
    GTK_EXPAND=0;GTK_FILL=1;GTK_EXPAND=2;GTK_FILL=3;
    TRUE=1;
    FALSE=0;

    pdata.window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_window_set_resizable (pdata.window, TRUE);

    g_signal_connect (pdata.window, "destroy","destroy_progress")
    gtk_window_set_title (pdata.window, "GtkProgressBar");

    gtk_container_set_border_width (pdata.window, 0);

    vbox = gtk_vbox_new (FALSE, 5);
    gtk_container_set_border_width ((vbox), 10);
    gtk_container_add (pdata.window, vbox);
    gtk_widget_show (vbox);
  
    %/* Create a centering alignment object */
    align = gtk_alignment_new (0.5, 0.5, 0, 0);
    gtk_box_pack_start ((vbox), align, FALSE, FALSE, 5);
    gtk_widget_show (align);

    %/* Create the GtkProgressBar */
    pdata.pbar = gtk_progress_bar_new ();

    gtk_container_add ((align), pdata.pbar);
    gtk_widget_show (pdata.pbar);

    %/* Add a timer callback to update the value of the progress bar */
    pdata.timer = gtk_timeout_add (100, "progress_timeout");

    separator = gtk_hseparator_new ();
    gtk_box_pack_start ((vbox), separator, FALSE, FALSE, 0);
    gtk_widget_show (separator);

    %/* rows, columns, homogeneous */
    table = gtk_table_new (2, 3, FALSE);
    gtk_box_pack_start ((vbox), table, FALSE, TRUE, 0);
    gtk_widget_show (table);

    %/* Add a check button to select displaying of the trough text */
    check = gtk_check_button_new_with_label ("Show text");
    gtk_table_attach ((table), check, 0, 1, 0, 1,
                      GTK_EXPAND + GTK_FILL, GTK_EXPAND + GTK_FILL,
		      5, 5);
    g_signal_connect ((check), "clicked",
                      ("toggle_show_text"))

    gtk_widget_show (check);

    %/* Add a check button to toggle activity mode */
    check = gtk_check_button_new_with_label ("Activity mode");
    gtk_table_attach ( (table), check, 0, 1, 1, 2,
                      (GTK_EXPAND+GTK_FILL),( GTK_EXPAND+GTK_FILL),
                      5, 5);
    g_signal_connect ((check), "clicked",("toggle_activity_mode"))
    gtk_widget_show (check);

    %/* Add a check button to toggle orientation */
    check = gtk_check_button_new_with_label ("Right to Left");
    gtk_table_attach ((table), check, 0, 1, 2, 3,
                      GTK_EXPAND+GTK_FILL, GTK_EXPAND+GTK_FILL,
                      5, 5);
    g_signal_connect ( (check), "clicked",("toggle_orientation"))
    gtk_widget_show (check);

    %/* Add a button to exit the program */
    button = gtk_button_new_with_label ("close");
    g_signal_connect((button), "clicked",("gtk_widget_destroy"));
    gtk_box_pack_start ((vbox), button, FALSE, FALSE, 0);

    %/* This makes it so the button is the default. */
    %GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);

    %/* This grabs this button to be the default button. Simply hitting
    %* the "Enter" key will cause this button to activate. */
    %gtk_widget_grab_default (button);
    gtk_widget_show (button);
    gtk_widget_show (pdata.window);
    gtk_main ();    
    return;
end

main()
