#! /usr/bin/octave -q

% A simple program to show
% the Use of "Arrow Widgets" from Octave-GTK.
% (C) Feb 2005 Muthiah Annamalai


% Create an Arrow widget with the specified parameters
% and pack it into a button 
function destroy(widget)
     gtk_main_quit()
end

function main( )
     %load library
     gtk()

     %initation
     gtk_init()

     %some enums: ugly but works... ;-0
     FALSE=0;
     TRUE=1;
     GTK_WINDOW_TOPLEVEL=0;
     GTK_POLICY_AUTOMATIC=0
     GTK_POLICY_ALWAYS=1
     NULL=0
     window=0
     scrolled_window=0

     %/* Initialize the toolkit */
     gtk_init();
     
     %/* Create a new window */
     window = gtk_window_new (GTK_WINDOW_TOPLEVEL);     
     gtk_window_set_title ((window), "GtkScrolledWindow example");
     gtk_container_set_border_width (window, 0);
     gtk_widget_set_size_request (window, 300, 300);
     
     %/* It's a good idea to do this for all windows. */
     g_signal_connect (window,"destroy","gtk_main_quit");
    
     scrolled_window = gtk_scrolled_window_new (NULL, NULL);
     gtk_scrolled_window_set_policy ((scrolled_window),
                                     GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
     gtk_container_set_border_width (scrolled_window,10);
     %/* Create a box to hold the arrows/buttons */
     box = gtk_vbox_new (0, 0);
     gtk_container_set_border_width (box,10);
     gtk_container_add(window, box);
     
     %/* Pack and show all our widgets */
     gtk_widget_show (box);
     
     gtk_box_pack_start (box, scrolled_window, TRUE, TRUE, 3);
     gtk_widget_show(scrolled_window);

    %/* create a table of 10 by 10 squares. */
    table = gtk_table_new (10, 10, FALSE);
    
    %/* set the spacing to 10 on x and 10 on y */
    gtk_table_set_row_spacings ((table), 10);
    gtk_table_set_col_spacings ((table), 10);
    
    %/* pack the table into the scrolled window */
    gtk_scrolled_window_add_with_viewport (
                  (scrolled_window), table);
    gtk_widget_show (table);
    
    %/* this simply creates a grid of toggle buttons on the table
    %* to demonstrate the scrolled window. */
    for i=0:10
      for j=0:10	
          buffer=sprintf ("button (%d,%d)\n", i, j);
	  button = gtk_toggle_button_new_with_label (buffer);
	  gtk_table_attach_defaults ((table), button,
	                             i, i+1, j, j+1);
          gtk_widget_show (button);
	end
      end
	 
    %/* Add a "close" button to the bottom of the dialog */
    button = gtk_button_new_with_label ("close");
    g_signal_connect((button),"clicked",("gtk_main_quit"));
    
    gtk_box_pack_start (box, button, FALSE, FALSE, 0);    
    gtk_widget_show_all (window);

%    Rest in gtk_main and wait for the fun to begin!
     gtk_main ();
     return ;
end

main()
